<template>
  <div>
    <v-card flat class="pa-10">
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <v-row>
        <v-col :cols="12" :sm="12" :md="6" :lg="4" :xl="4">
          Clave
          <span class="tRojo">*</span>
          <br />
          <v-text-field
            v-model.trim="semaforo.clave"
            readonly
            disabled
            outlined
            solo
            maxlength="50"
            flat
            dense
            :error="$v.semaforo.clave.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(semaforo.clave, 200)
            "
            background-color="white"
          >
            <template v-if="$v.semaforo.clave.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.semaforo.clave.$reset" v-close-popover>
                    <div v-if="!$v.semaforo.clave.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-text-field>
        </v-col>
        <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
          Descripción
          <span class="tRojo">*</span>
          <br />
          <v-text-field
            v-model.trim="semaforo.descripcion"
            outlined
            solo
            maxlength="50"
            flat
            dense
            :error="$v.semaforo.descripcion.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(semaforo.descripcion, 50)
            "
            background-color="white"
          >
            <template v-if="$v.semaforo.descripcion.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.semaforo.descripcion.$reset" v-close-popover>
                    <div v-if="!$v.semaforo.descripcion.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-text-field>
        </v-col>
      </v-row>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingSemaforo },
            { 'error-validation-btn': $v.$invalid },
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </v-card>
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh!</strong>
            Tienes algunos conflictos de validación
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡No hay de que preocuparse! Solo tienes que corregirlos
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh! Advertencia</strong>
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh...! </strong>
            Todo salió bien
            <v-icon right color="green">mdi-check-circle-outline</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡Tus datos fueron guardados!
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Entiendo</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.fixed.tooltiptext3 .fixed.tooltiptext4 {
  bottom: -15px;
  left: -40px;
}
.tooltiptext3 .tooltiptext4 {
  bottom: -40px;
  left: -60px;
}
.tooltiptext3 .tooltiptext4 {
  bottom: -30px;
  left: -40px;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import store from "@/store";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
import { required } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-DatosSemaforo",
  components: {
    LeavePage,
  },
  props: ["semaforoIn"],
  data() {
    return {
      savingSemaforo: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      semaforoBackup: {
        idSemaforo: null,
        clave: "",
        descripcion: "",
      },
      semaforo: {
        idSemaforo: null,
        clave: "",
        descripcion: "",
      },
    };
  },
  validations: {
    semaforo: {
      clave: {
        required,
      },
      descripcion: {
        required,
      },
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.semaforoBackup) {
        const originalValue = JSON.stringify(this.semaforoBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.semaforo).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.semaforo.idSemaforo === undefined;
      }
    },
  },
  methods: {
    guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        this.savingSemaforo = true;
        let body = {
          clave: this.semaforo.clave,
          descripcion: this.semaforo.descripcion,
        };
        axios
          .put(
            "/sistema-informacion/tablero/semaforos/v1/" +
              this.semaforo.idSemaforo,
            body
          )
          .then((response) => {
            this.semaforoBackup = JSON.parse(JSON.stringify(this.semaforo));
            this.dialogSave = true;
            this.$emit("changeSemaforo", this.semaforo);
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          })
          .finally(() => {
            this.savingSemaforo = false;
          });
      } else {
        this.dialogErrorValidation = true;
      }
    },
    cancelGlobalChanges() {
      this.semaforo = JSON.parse(JSON.stringify(this.semaforoBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
  },
  created() {
    this.semaforo = JSON.parse(JSON.stringify(this.semaforoIn));
    this.semaforoBackup = JSON.parse(JSON.stringify(this.semaforo));
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  },
};
</script>
